<template>
  <div class="energy-page fixed inset-0">
    <Header title="Energy" :onBack="backToMain" />

    <div class="main pt-[106px]">
      <div class="h-[36px] px-4 text-right">
        <input
          v-if="selected_meter.id"
          type="month"
          v-model="month"
          class="px-3 py-1 text-black rounded-md w-[230px] focus:outline-none"
          @change="changeMonth"
        />

        <span v-else class="font-semibold text-xl">ออกรายงาน</span>
      </div>

      <div
        style="height: calc(100vh - 142px)"
        class="p-4 grid grid-cols-4 grid-rows-1 gap-4"
      >
        <EnergyMap
          :map_data="map_data"
          :selected_meter="selected_meter"
          :selectMeter="selectMeter"
        />

        <template v-if="selected_meter.id">
          <div class="rounded-md p-4 bg-darkblue border-primary border">
            <EnergyMeter :selected_meter="selected_meter" />
          </div>

          <div class="col-span-2 grid grid-cols-2 grid-rows-3 gap-4">
            <div class="rounded-md p-4 bg-darkblue border-primary border">
              <EnergyLineChart
                title="Frequency"
                :chart_data="selected_meter.frequencies"
                class="h-full"
              />
            </div>

            <div class="rounded-md p-4 bg-darkblue border-primary border">
              <EnergyLineChart
                title="Energy"
                :chart_data="selected_meter.energys"
                class="h-full"
              />
            </div>

            <div class="rounded-md p-4 bg-darkblue border-primary border">
              <EnergyLineChart
                title="Voltage"
                :chart_data="selected_meter.voltages"
                class="h-full"
              />
            </div>

            <div class="rounded-md p-4 bg-darkblue border-primary border">
              <EnergyLineChart
                title="Current"
                :chart_data="selected_meter.currents"
                class="h-full"
              />
            </div>

            <div
              class="col-span-2 rounded-md p-4 bg-darkblue border-primary border"
            >
              <EnergyLineChart
                title="Power"
                :chart_data="selected_meter.powers"
                class="h-full"
              />
            </div>
          </div>
        </template>

        <div
          v-else
          class="col-span-3 rounded-md px-4 pt-4 bg-darkblue border-primary border"
        >
          <EnergyStatisticChart
            :chart_data="_.reverse([...statistic_data])"
            :selected_table_item="selected_table_item"
            :selectTableItem="selectTableItem"
            class="h-2/4"
          />

          <EnergyBillTable
            :table_items="statistic_data"
            :selected_table_item="selected_table_item"
            :selectTableItem="selectTableItem"
            :selectMeter="selectMeter"
            class="h-2/4"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import _ from "lodash";
import moment from "moment";

export default {
  data() {
    return {
      statistic_data: [
        {
          id: 12,
          month: "ธันวาคม",
          month_abb: "ธ.ค.",
          year: "2564",
          unit: 916,
          unit_diff: {
            value: 1016,
            status: "up",
          },
          price: 1500,
          price_diff: {
            value: 1016,
            status: "down",
          },
          meter_detail: {
            table_heads: [
              {
                name: "ชื่อมิเตอร์",
                key: "name",
                class: "p-2 text-left w-[160px]",
              },
              {
                name: "ตำแหน่่ง",
                key: "position",
                class: "p-2 text-left w-[90px]",
              },
              {
                name: "จำนวนหน่วย",
                key: "unit",
                class: "p-2 text-center w-[100px]",
              },
              {
                name: "ค่าไฟฟ้า",
                key: "estimated_cost",
                class: "p-2 text-center w-[90px]",
              },
            ],
            table_items: [
              {
                id: 1,
                name: "meter energy 001",
                status: "offline",
                position: {
                  name: "หาดพยูน",
                  lat: 13.736717,
                  lng: 100.523186,
                },
                voltages: [
                  {
                    time: "14:00",
                    value: 50.0,
                  },
                  {
                    time: "15:00",
                    value: 50.0,
                  },
                ],
                frequencies: [
                  {
                    time: "14:00",
                    value: 150.0,
                  },
                  {
                    time: "15:00",
                    value: 250.0,
                  },
                  {
                    time: "16:00",
                    value: 50.0,
                  },
                  {
                    time: "17:00",
                    value: 40.0,
                  },
                ],
                powers: [
                  {
                    time: "14:00",
                    value: 50.0,
                  },
                  {
                    time: "15:00",
                    value: 80.0,
                  },
                ],
                currents: [
                  {
                    time: "14:00",
                    value: 50.0,
                  },
                  {
                    time: "15:00",
                    value: 50.0,
                  },
                ],
                energys: [
                  {
                    time: "14:00",
                    value: 50.0,
                  },
                  {
                    time: "15:00",
                    value: 50.0,
                  },
                ],
                unit: 11555,
                no: 2002012288,
                energy_consum_monthly: 20.15,
                estimated_cost: 80.82,
              },
              {
                id: 2,
                name: "meter energy 002",
                status: "normal",
                position: {
                  name: "หาดพยูน",
                  lat: 13.764955,
                  lng: 100.538317,
                },
                voltages: [
                  {
                    time: "14:00",
                    value: 50.0,
                  },
                  {
                    time: "15:00",
                    value: 100.0,
                  },
                ],
                frequencies: [
                  {
                    time: "14:00",
                    value: 150.0,
                  },
                  {
                    time: "15:00",
                    value: 250.0,
                  },
                  {
                    time: "16:00",
                    value: 50.0,
                  },
                  {
                    time: "17:00",
                    value: 40.0,
                  },
                ],
                powers: [
                  {
                    time: "14:00",
                    value: 50.0,
                  },
                  {
                    time: "15:00",
                    value: 50.0,
                  },
                ],
                currents: [
                  {
                    time: "14:00",
                    value: 50.0,
                  },
                  {
                    time: "15:00",
                    value: 150.0,
                  },
                ],
                energys: [
                  {
                    time: "14:00",
                    value: 30.0,
                  },
                  {
                    time: "15:00",
                    value: 50.0,
                  },
                ],
                unit: 11234,
                no: 2002012288,
                energy_consum_monthly: 20.15,
                estimated_cost: 80.82,
              },
            ],
          },
        },
        {
          id: 11,
          month: "พฤศจิกายน",
          month_abb: "พ.ย.",
          year: "2564",
          unit: 1016,
          unit_diff: {
            value: 1016,
            status: "up",
          },
          price: 2000,
          price_diff: {
            value: 1016,
            status: "down",
          },
        },
        {
          id: 10,
          month: "ตุลาคม",
          month_abb: "ต.ค.",
          year: "2564",
          unit: 1016,
          unit_diff: {
            value: 1016,
            status: "up",
          },
          price: 2000,
          price_diff: {
            value: 1016,
            status: "down",
          },
        },
        {
          id: 9,
          month: "กันยายน",
          month_abb: "ก.ย.",
          year: "2564",
          unit: 1016,
          unit_diff: {
            value: 1016,
            status: "up",
          },
          price: 2000,
          price_diff: {
            value: 1016,
            status: "down",
          },
        },
        {
          id: 8,
          month: "สิงหาคม",
          month_abb: "ส.ค.",
          year: "2564",
          unit: 1016,
          unit_diff: {
            value: 1016,
            status: "up",
          },
          price: 2000,
          price_diff: {
            value: 1016,
            status: "down",
          },
        },
        {
          id: 7,
          month: "กรกฎาคม",
          month_abb: "ก.ค.",
          year: "2564",
          unit: 1016,
          unit_diff: {
            value: 1016,
            status: "up",
          },
          price: 2000,
          price_diff: {
            value: 1016,
            status: "down",
          },
        },
        {
          id: 6,
          month: "มิถุนายน",
          month_abb: "มิ.ย.",
          year: "2564",
          unit: 1016,
          unit_diff: {
            value: 1016,
            status: "up",
          },
          price: 2000,
          price_diff: {
            value: 1016,
            status: "down",
          },
        },
        {
          id: 5,
          month: "พฤษภาคม",
          month_abb: "พ.ค.",
          year: "2564",
          unit: 1016,
          unit_diff: {
            value: 1016,
            status: "up",
          },
          price: 2000,
          price_diff: {
            value: 1016,
            status: "down",
          },
        },
        {
          id: 4,
          month: "เมษายน",
          month_abb: "เม.ย.",
          year: "2564",
          unit: 1016,
          unit_diff: {
            value: 1016,
            status: "up",
          },
          price: 2000,
          price_diff: {
            value: 1016,
            status: "down",
          },
        },
        {
          id: 3,
          month: "มีนาคม",
          month_abb: "มี.ค.",
          year: "2564",
          unit: 1016,
          unit_diff: {
            value: 1016,
            status: "up",
          },
          price: 2000,
          price_diff: {
            value: 1016,
            status: "down",
          },
        },
        {
          id: 2,
          month: "กุมภาพันธ์",
          month_abb: "ก.พ.",
          year: "2564",
          unit: 1016,
          unit_diff: {
            value: 1016,
            status: "up",
          },
          price: 2000,
          price_diff: {
            value: 1016,
            status: "down",
          },
        },
        {
          id: 1,
          month: "มกราคม",
          month_abb: "ม.ค.",
          year: "2564",
          unit: 1016,
          unit_diff: {
            value: 1016,
            status: "up",
          },
          price: 2000,
          price_diff: {
            value: 1016,
            status: "down",
          },
        },
      ],
      map_data: [
        {
          id: 1,
          name: "meter energy 001",
          status: "offline",
          position: {
            name: "หาดพยูน",
            lat: 13.736717,
            lng: 100.523186,
          },
          voltages: [
            {
              time: "14:00",
              value: 50.0,
            },
            {
              time: "15:00",
              value: 50.0,
            },
          ],
          frequencies: [
            {
              time: "14:00",
              value: 150.0,
            },
            {
              time: "15:00",
              value: 250.0,
            },
            {
              time: "16:00",
              value: 50.0,
            },
            {
              time: "17:00",
              value: 40.0,
            },
          ],
          powers: [
            {
              time: "14:00",
              value: 50.0,
            },
            {
              time: "15:00",
              value: 80.0,
            },
          ],
          currents: [
            {
              time: "14:00",
              value: 50.0,
            },
            {
              time: "15:00",
              value: 50.0,
            },
          ],
          energys: [
            {
              time: "14:00",
              value: 50.0,
            },
            {
              time: "15:00",
              value: 50.0,
            },
          ],
          unit: 11555,
          no: 2002012288,
          energy_consum_monthly: 20.15,
          estimated_cost: 80.82,
        },
        {
          id: 2,
          name: "meter energy 002",
          status: "normal",
          position: {
            name: "หาดพยูน",
            lat: 13.764955,
            lng: 100.538317,
          },
          voltages: [
            {
              time: "14:00",
              value: 50.0,
            },
            {
              time: "15:00",
              value: 100.0,
            },
          ],
          frequencies: [
            {
              time: "14:00",
              value: 150.0,
            },
            {
              time: "15:00",
              value: 250.0,
            },
            {
              time: "16:00",
              value: 50.0,
            },
            {
              time: "17:00",
              value: 40.0,
            },
          ],
          powers: [
            {
              time: "14:00",
              value: 50.0,
            },
            {
              time: "15:00",
              value: 50.0,
            },
          ],
          currents: [
            {
              time: "14:00",
              value: 50.0,
            },
            {
              time: "15:00",
              value: 150.0,
            },
          ],
          energys: [
            {
              time: "14:00",
              value: 30.0,
            },
            {
              time: "15:00",
              value: 50.0,
            },
          ],
          unit: 11234,
          no: 2002012288,
          energy_consum_monthly: 20.15,
          estimated_cost: 80.82,
        },
        {
          id: 3,
          name: "meter energy 003",
          status: "normal",
          position: {
            name: "หาดพยูน",
            lat: 13.765955,
            lng: 100.539317,
          },
          voltages: [
            {
              time: "14:00",
              value: 50.0,
            },
            {
              time: "15:00",
              value: 100.0,
            },
          ],
          frequencies: [
            {
              time: "14:00",
              value: 150.0,
            },
            {
              time: "15:00",
              value: 250.0,
            },
            {
              time: "16:00",
              value: 50.0,
            },
            {
              time: "17:00",
              value: 40.0,
            },
          ],
          powers: [
            {
              time: "14:00",
              value: 50.0,
            },
            {
              time: "15:00",
              value: 50.0,
            },
          ],
          currents: [
            {
              time: "14:00",
              value: 50.0,
            },
            {
              time: "15:00",
              value: 150.0,
            },
          ],
          energys: [
            {
              time: "14:00",
              value: 30.0,
            },
            {
              time: "15:00",
              value: 50.0,
            },
          ],
          unit: 11234,
          no: 2002012288,
          energy_consum_monthly: 20.15,
          estimated_cost: 80.82,
        },
      ],
      selected_table_item: {},
      selected_meter: {},
      month: moment().format("YYYY-MM"),
    };
  },
  computed: {
    _() {
      return _;
    },
  },
  created() {
    // this.getData()
    // dom not render
  },
  mounted() {
    // this.getData()
    // dom rendered
  },
  methods: {
    backToMain() {
      this.selected_table_item = {};
      this.selected_meter = {};
    },
    selectTableItem(item) {
      this.selected_table_item =
        this.selected_table_item.id === item.id ? {} : item;
    },
    selectMeter(meter) {
      this.selected_meter = meter;
    },
    changeMonth: _.debounce(async function () {
      console.log(this.month);

      try {
        const res = await this.$appApi.$get(`/endpoint`, {
          params: {
            month: this.month,
          },
        });

        // this.statistic_data = ...
        // this.map_data = ...
      } catch (error) {
        console.log(error);
      }
    }, 200),

    // call api example
    // async getData() {
    //   try {
    //     const res = await this.$appApi.$get(`/endpoint`, { params: {} });
    //   } catch (error) {
    //     console.log(error);
    //   }
    // },
    // async postData() {
    //   try {
    //     const res = await this.$appApi.$post(`/endpoint`, {});
    //   } catch (error) {
    //     console.log(error);
    //   }
    // },
    // async patchData() {
    //   try {
    //     const res = await this.$appApi.$patch(`/endpoint`, {});
    //   } catch (error) {
    //     console.log(error);
    //   }
    // },
    // async deleteData() {
    //   try {
    //     const res = await this.$appApi.$delete(`/endpoint`, {});
    //   } catch (error) {
    //     console.log(error);
    //   }
    // },
  },
};
</script>

<style lang="scss" scoped></style>
